/* Custom-Klasse zur Darstellung von nicht-rechteckigen Fenstern
   Programmierer : Marc Van den Berghen
   16-07-2004

   This is one half of the region-Package, which enables 
   developper to design Forms or Controls in any shape.

   To find out how it is used, see the help.txt

*/

class Windowrgn(cfile,oparent) of object 

	this.filename 	= cfile		// region-file
	this.oparent	= oparent   // which window should be clipped?

   // Prepare the API-Calls
	extern CINT SetWindowRgn(CHANDLE, CHANDLE, CLOGICAL) user32
	extern CUINT CombineRgn(chandle, chandle, chandle, CINT) gdi32
	extern chandle  CreateRectRgn(cint,cint,cint,cint) gdi32
	extern clong  SendMessage(chandle, CUINT, cuint, cuint) user32 from "SendMessageA"
	extern clogical DeleteObject(chandle) gdi32
   extern clong GetWindowLongA(chandle,cint) user32
   extern clong SetWindowLongA(chandle,cint,clong) user32


	function clip()
   *==============
   	*  get the region from disk
		local f,tt,sr1,start,xa,xl,i,xoff,yoff,rtmp,res,wstyle

		* the following is used, to make sure that no border effects will
      * interfere with the region

      wstyle=getwindowlonga(this.oparent.hwnd,-16)
      wstyle=bitand(wstyle,0xFF03FFFF)
      setwindowlonga(this.oparent.hwnd,-16,wstyle)

      *  get the region from disk
	   f= new file()
	   f.open(this.filename,"R")
	   f.seek(0)
	   tt=f.size(this.filename)
	   sr1=f.read(tt)
	   f.close()

      * adjust window-size with region-size
      this.oparent.width=this.getword(sr1,0)
      this.oparent.height=this.getword(sr1,2)

		* create region on the fly with file from disk
	   start=createrectrgn(0,0,0,0)
   	xa=0;xl=0;y=0
	   for i=4 to tt step 4
	      xl= class::getword(sr1,i+2)
	      if xl=0
   	       y++
      	else
         	xa=this.getword(sr1,i)
	         rtmp=createrectrgn(xa-1,y,xa+xl-1,y+1)
   	      res=combinergn(start,start,rtmp,2)
      	   deleteobject(rtmp)
	      endif
   	endfor                  
	   setwindowrgn(this.oparent.hwnd,start,true)
	return

	function getword(c_sr,n_pos)
   *===========================
	return (asc(substr(c_sr,n_pos+1,1))*256+asc(substr(c_sr,n_pos+2,1)))

	function move()
   *==============
   	SendMessage(this.oparent.hwnd, 0x00A1,2, 0)
	return

   function cleanup
   *===============
   	this.oparent=Null
      this.filename=null
      release object this
   return

endclass


